
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================
//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_DDR4C
//`define ENABLE_DDR4D
//`define ENABLE_PCIE
//`define ENABLE_QSFPDDA
//`define ENABLE_QSFPDDB
//`define ENABLE_QSFPRSV_REFCLK
//`define ENABLE_DDR4_DUAL_RANK

module DE10_Agilex_Clock_Controller #(
`ifdef ENABLE_DDR4_DUAL_RANK
      parameter RANK = 1
`else
      parameter RANK = 0
`endif
   )
   (

      ///////// CLOCK /////////
      input              CLK_100_B2A,
      input              CLK_50_B3A,
      input              CLK_50_B3C,
      input              UFL_CLKIN,
      input              CLK_30M72, //reserved for future use
      input    [ 1: 0]   CLK_from_SI5397A_p,//0:OUT0 , 1:OUT4 , 
      output   [ 1: 0]   CLK_to_SI5397A_p  ,  //0:30.27MHZ , 1:31.25MHZ

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON, //BUTTON is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 3: 0]   LED_BRACKET, //LED is Low-Active
      output   [ 3: 0]   LED, //LED is Low-Active

      ///////// SI5397A /////////
      inout              SI5397A_I2C_SCL,
      inout              SI5397A_I2C_SDA,
      input              SI5397A_LOL_A,
      input              SI5397A_LOL_B,
      input              SI5397A_LOL_C,
      input              SI5397A_LOL_D,
      input              SI5397A_LOS_XAXB,
      output             SI5397A_OE_n,
      output             SI5397A_RST_n,

      ///////// GPIO /////////
      //input    [ 1: 0]   GPIO_CLK,
      //inout    [ 3: 0]   GPIO_p,

      input              QSFPDDA_REFCLK_p,
      input              QSFPDDB_REFCLK_p,
      ///////// QSFPDDRSV /////////
      input              QSFPDDRSV_REFCLK_p

//      input              DDR4A_REFCLK_p,

      ///////// DDR4B /////////
//      input              DDR4B_REFCLK_p,

      ///////// DDR4C /////////

//      input              DDR4D_REFCLK_p,
//      input    [ 1: 0]   PCIE_REFCLK_p,

      ///////// AG /////////
      //output             AG_UART_TX,
      //input              AG_UART_RX,
      //input              AG_UART_CTS,
      //output             AG_UART_RTS,

      ///////// EXP /////////
      //input              EXP_EN,

      ///////// INFO /////////
      //output             INFO_SPI_SCLK,
      //input              INFO_SPI_MISO,
      //output             INFO_SPI_MOSI,
      //output             INFO_SPI_CS_n

);
  

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [3:0]  SW_SET_XCVR ; 
wire [3:0]  SW_SET_IO ; 
wire [3:0]  HZ; 
wire        M50_1HZ ; 
wire        si5397a_controller_start;
wire        si5397a_config_done;
wire        tx_clkout_QSFPDDA_REFCLK_p;
wire        tx_clkout_QSFPDDB_REFCLK_p;
wire        tx_clkout_QSFPDDRSV_REFCLK_p ; 

//=======================================================
//  Structural coding
//=======================================================
wire locked_0,locked_1; 
PLL iopll (
		.rst      (~CPU_RESET_n),
		.refclk   (CLK_100_B2A),  
		.locked   (locked_0),     
		.outclk_0 (CLK_to_SI5397A_p[0])    // CLK_to_SI5397A_p, 30.27MHZ 
	);
	
PLL_0 iopll_0 (
		.rst      (~CPU_RESET_n),
		.refclk   (CLK_50_B3A),  
		.locked   (locked_1),     
		.outclk_0 (CLK_to_SI5397A_p[1])   // CLK_to_SI5397A_p,  31.25MHZ
	);	

//=======================================================
//  Configure SI5397A 
//=======================================================


//----- KEY Selection
BUT_SET B_xcvr( .CPU_RESET_n(CPU_RESET_n)  , .CLK (CLK_50_B3C), .BT(BUTTON[1]), .SW_MAX (10),  .SW_SET (SW_SET_XCVR) );
BUT_SET B_io  ( .CPU_RESET_n(CPU_RESET_n)  , .CLK (CLK_50_B3C), .BT(BUTTON[1]), .SW_MAX (4) ,  .SW_SET (SW_SET_IO) );


//----- Configure SI5397A 
// XA(48MHz) --> DSPLLx free run(no clean) --> OUT2/6(7) --> FPGA XCVR bank
`define XCVR_644M53125     4'h0  
`define XCVR_625M          4'h1  
`define XCVR_322M265625    4'h2  
`define XCVR_312M5         4'h3  
`define XCVR_307M2         4'h4  
`define XCVR_250M          4'h5  
`define XCVR_184M32        4'h6 
`define XCVR_156M25        4'h7  // (default)
`define XCVR_153M6         4'h8  
`define XCVR_125M          4'h9  
`define XCVR_100M          4'hA  

// XA/INx --> PLL clean --> OUT0/4 --> FPGA IO bank
`define IO_50M             4'h0  // XA 48MHz --> DSPLL free-run 50MHZ --> OUT (default)
`define IO_IN0             4'h1  // IN0 (from FPGA, assume 30.72MHz)--> DSPLLx clean --> OUT
`define IO_IN1             4'h2  // IN1 (from FPGA, assume 31.25MHz)--> DSPLLx clean --> OUT  
`define IO_IN2             4'h3  // IN2 (30.72MHz)--> DSPLLx clean --> OUT  
`define IO_IN3             4'h4  // IN3 (from UFL, assume 10MHz)--> DSPLLx clean --> OUT  


//----- reconfig Si5340-----
assign si5397a_controller_start = ~BUTTON[0];
	 
DE10AGILEX_SI5397A_CONFIG  si5397a_controller(
.iCLK         (CLK_50_B3A),
.iRST_n       (1'b1),
.iStart       (si5397a_controller_start), // rise edge trigger
.iXCVR_CLK_0  (SW_SET_XCVR),  // OUT2 frequency specified by constant XCVR_XXX. FPGA pin QSFPDDA_REFCLK_p 
.iXCVR_CLK_1  (SW_SET_XCVR),  // OUT6 frequency specified by constant XCVR_XXX. FPGA pin QSFPDDB_REFCLK_p 
.iXCVR_CLK_RSV(1'b1),          // OUT7 output control. 1: enable out, 0: disable output. FPGA pin QSFPDDRSV_REFCLK_p
.iIO_CLK_0    (SW_SET_IO),       // OUT0 frequency specified by constant IO_XXX. FPGA pin CLK_from_Si55397A[0]
.iIO_CLK_1    (SW_SET_IO),       // OUT4 frequency specified by constant IO_XXX. FPGA pin CLK_from_Si55397A[1]              
.REG_CONFIG_DONE(si5397a_config_done),
// Si5397A conduit
.I2C_CLK (SI5397A_I2C_SCL),
.I2C_DATA(SI5397A_I2C_SDA)
);

assign SI5397A_OE_n  = 1'b0;
assign SI5397A_RST_n = 1'b1; 

//----- heart
CLOCKMEM  HZ_CLK_50_B3C         ( .RESET_n(BUTTON[0]  ) ,.CLK( CLK_50_B3C                   ),.CLK_FREQ   ( 50000000 )  ,.CK_1HZ( HZ[0] ) ) ;
CLOCKMEM  HZ_QSFPDDA_REFCLK_p   ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDA_REFCLK_p   ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[1] ) ) ;
CLOCKMEM  HZ_QSFPDDB_REFCLK_p   ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDB_REFCLK_p   ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[2] ) ) ;
CLOCKMEM  HZ_QSFPDDRSV_REFCLK_p ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDRSV_REFCLK_p ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[3] ) ) ;


//----- LED Display
assign LED         = ~si5397a_config_done ? 4'b0000: 
            { 
             ~(SI5397A_LOL_D |  HZ[3]) ,
             ~(SI5397A_LOL_C |  HZ[2]) ,
             ~(SI5397A_LOL_B |  HZ[1]) ,
             ~(SI5397A_LOL_A |  HZ[0]) 
} ;

assign LED_BRACKET = 4'b1111 ; 

//----------REFCLK Measure , view SignalTapeII --------
//--1hz generater 
CLOCKMEM  ck2( .RESET_n(BUTTON[0]), .CLK(CLK_50_B3C) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;


//----view frequency by SignalTapeII --------

FRE_MEASURE fCLK_30M72           ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_30M72 )   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fCLK_from_SI5397A_p_0( .RESET_n(BUTTON[0]),.MES_CLK (CLK_from_SI5397A_p[0])   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fCLK_from_SI5397A_p_1( .RESET_n(BUTTON[0]),.MES_CLK (CLK_from_SI5397A_p[1])   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fQSFPDDA_REFCLK_p    ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDA_REFCLK_p)   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fQSFPDDB_REFCLK_p    ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDB_REFCLK_p)   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fQSFPDDRSV_REFCLK_p  ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDRSV_REFCLK_p) , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fCLK_100_B2A         ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_100_B2A)                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B3A          ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_50_B3A )                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B3C          ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_50_B3C )                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 


//--refclock by way of xcvrphy  to  pll_out1 
e_tile_pll visu0( .pll_refclk0( QSFPDDA_REFCLK_p  ), .pll_clkout1 ( tx_clkout_QSFPDDA_REFCLK_p  ));
e_tile_pll visu1( .pll_refclk0( QSFPDDB_REFCLK_p  ), .pll_clkout1 ( tx_clkout_QSFPDDB_REFCLK_p  ));
e_tile_pll visu2( .pll_refclk0( QSFPDDRSV_REFCLK_p), .pll_clkout1 ( tx_clkout_QSFPDDRSV_REFCLK_p));

endmodule
