#include "terasic_includes.h"
//#include "i2c.h"
#include "i2c_core.h"
#include "si5397A_config.h"


//#define SI5397_DEBUG(x)    DEBUG(x)

bool SI5397A_w_reg_only(uint32_t i2c_base, uint8_t reg_index, uint8_t data8);

typedef struct
{
    uint8_t address; /* 8-bit register address */
    uint8_t value; /* 8-bit register data */

} si5397_register_t;

bool SI5397A_Config_Init(uint32_t i2c_base)
{
    bool bSuccess = TRUE;
    uint8_t dataR, dataR_1;

    bSuccess = oc_i2c_init(i2c_base);

//    if (bSuccess)
//        bSuccess = SI5397A_w_reg(i2c_base, REGA_ADDR_PAGE, 0x00); // Page  0
//
//    if (bSuccess)
//        bSuccess = SI5397A_r_reg(i2c_base, 0x00, &dataR); // DIE_REV
//    if (bSuccess)
//        printf("Die Revision Number = %d\n", dataR & 0xf);
//
//    if (bSuccess)
//        bSuccess = SI5397A_r_reg(i2c_base, 0x02, &dataR); // PN_BASE
//    if (bSuccess)
//        bSuccess = SI5397A_r_reg(i2c_base, 0x03, &dataR_1); // PN_BASE
//    if (bSuccess)
//        printf("OPN: %02x%02x\n", dataR_1, dataR);

    return bSuccess;
}

bool SI5397A_Config(uint32_t i2c_base, SI5397A_FREQ_ID FreqID0, SI5397A_FREQ_ID FreqID2, SI5397A_FREQ_ID FreqID4,
        SI5397A_FREQ_ID FreqID6, SI5397A_FREQ_ID FreqID7)
{
    bool bSuccess = TRUE;

    uint8_t LOL_FST_EN_PLLC;
    uint8_t LOL_FST_EN_PLLD;
    uint8_t LOL_FST_DETWIN_SEL_PLLC;
    uint8_t LOL_FST_DETWIN_SEL_PLLD;
    uint8_t LOL_FST_SET_THR_SEL_PLLC;
    uint8_t LOL_FST_SET_THR_SEL_PLLD;
    uint8_t LOL_FST_CLR_THR_SEL_PLLC;
    uint8_t LOL_FST_CLR_THR_SEL_PLLD;
    uint8_t LOL_SLOW_EN_PLLC;
    uint8_t LOL_SLOW_EN_PLLD;
    uint8_t LOL_SLW_DETWIN_SEL_PLLC;
    uint8_t LOL_SLW_DETWIN_SEL_PLLD;
    uint8_t LOL_SLW_SET_THR_PLLC;
    uint8_t LOL_SLW_SET_THR_PLLD;
    uint8_t LOL_SLW_CLR_THR_PLLC;
    uint8_t LOL_SLW_CLR_THR_PLLD;
    uint32_t LOL_CLR_DELAY_DIV256_PLLC;
    uint32_t LOL_CLR_DELAY_DIV256_PLLD;
    uint32_t FASTLOCK_EXTEND_PLLC;
    uint32_t FASTLOCK_EXTEND_PLLD;

    uint8_t OUT0_RDIV_FORCE2;
    uint8_t OUT4_RDIV_FORCE2;
    uint8_t OUT7_OE;

    uint32_t R0_REG;
    uint32_t R4_REG;
    uint8_t FASTLOCK_EXTEND_SCL_PLLC;
    uint8_t FASTLOCK_EXTEND_SCL_PLLD;
    uint8_t LOL_SLW_VALWIN_SELX_PLLC;
    uint8_t LOL_SLW_VALWIN_SELX_PLLD;
    uint8_t FASTLOCK_DLY_ONSW_EN_PLLC;
    uint8_t FASTLOCK_DLY_ONSW_EN_PLLD;
    uint8_t FASTLOCK_DLY_ONLOL_EN_PLLC;
    uint8_t FASTLOCK_DLY_ONLOL_EN_PLLD;
    uint32_t FASTLOCK_DLY_ONLOL_PLLC;
    uint32_t FASTLOCK_DLY_ONLOL_PLLD;
    uint32_t FASTLOCK_DLY_ONSW_PLLC;
    uint32_t FASTLOCK_DLY_ONSW_PLLD;

    uint64_t N0_NUM;
    uint64_t N1_NUM;
    uint64_t N2_NUM;
    uint32_t N2_DEN;
    uint64_t N3_NUM;
    uint32_t N3_DEN;

    uint8_t BW0_PLLC;
    uint8_t BW1_PLLC;
    uint8_t BW2_PLLC;
    uint8_t BW3_PLLC;
    uint8_t BW4_PLLC;
    uint8_t BW5_PLLC;
    uint8_t FASTLOCK_BW0_PLLC;
    uint8_t FASTLOCK_BW1_PLLC;
    uint8_t FASTLOCK_BW2_PLLC;
    uint8_t FASTLOCK_BW3_PLLC;
    uint8_t FASTLOCK_BW4_PLLC;
    uint8_t FASTLOCK_BW5_PLLC;
    uint64_t M_NUM_PLLC;
    uint32_t M_DEN_PLLC;
    uint8_t M_FRAC_EN_PLLC;
    uint8_t IN_SEL_PLLC;
    uint8_t HOLD_RAMP_BYP_PLLC;
    uint8_t RAMP_STEP_INTERVAL_PLLC;
    uint8_t HOLD_HIST_LEN_PLLC;
    uint8_t HOLD_HIST_DELAY_PLLC;
    uint16_t HOLD_15M_CYC_COUNT_PLLC;
    uint8_t FORCE_HOLD_PLLC;
    uint8_t CLK_SWITCH_MODE_PLLC;
    uint8_t HSW_COARSE_PM_LEN_PLLC;
    uint8_t HSW_COARSE_PM_DLY_PLLC;
    uint8_t HSW_FINE_PM_LEN_PLLC;
    uint16_t PFD_EN_DELAY_PLLC;
    uint32_t HSW_MEAS_SETTLE_PLLC;
    uint8_t HOLDEXIT_BW_SEL0_PLLC;
    uint8_t HOLD_FRZ_WITH_INTONLY_PLLC;
    uint8_t HOLD_RAMPPB_NOHIST_PLLC;
    uint8_t HOLDEXIT_BW0_PLLC;
    uint8_t HOLDEXIT_BW1_PLLC;
    uint8_t HOLDEXIT_BW2_PLLC;
    uint8_t HOLDEXIT_BW3_PLLC;
    uint8_t HOLDEXIT_BW4_PLLC;
    uint8_t HOLDEXIT_BW5_PLLC;
    uint8_t HSW_LIMIT_PLLC;
    uint8_t RAMP_STEP_SIZE_PLLC;
    uint8_t OUT_MAX_LIMIT_EN_PLLC;
    uint8_t HOLD_SETTLE_DET_EN_DSPLLC;
    uint16_t OUT_MAX_LIMIT_LMT_DPSLLC;
    uint16_t HOLD_SETTLE_TARGET_DSPLLC;

    uint8_t BW0_PLLD;
    uint8_t BW1_PLLD;
    uint8_t BW2_PLLD;
    uint8_t BW3_PLLD;
    uint8_t BW4_PLLD;
    uint8_t BW5_PLLD;
    uint8_t FASTLOCK_BW0_PLLD;
    uint8_t FASTLOCK_BW1_PLLD;
    uint8_t FASTLOCK_BW2_PLLD;
    uint8_t FASTLOCK_BW3_PLLD;
    uint8_t FASTLOCK_BW4_PLLD;
    uint8_t FASTLOCK_BW5_PLLD;
    uint64_t M_NUM_PLLD;
    uint32_t M_DEN_PLLD;
    uint8_t M_FRAC_EN_PLLD;
    uint8_t IN_SEL_PLLD;
    uint8_t HOLD_RAMP_BYP_PLLD;
    uint8_t RAMP_STEP_INTERVAL_PLLD;
    uint8_t HOLD_HIST_LEN_PLLD;
    uint8_t HOLD_HIST_DELAY_PLLD;
    uint32_t HOLD_15M_CYC_COUNT_PLLD;
    uint8_t FORCE_HOLD_PLLD;
    uint8_t CLK_SWITCH_MODE_PLLD;
    uint8_t HSW_COARSE_PM_LEN_PLLD;
    uint8_t HSW_COARSE_PM_DLY_PLLD;
    uint8_t HSW_FINE_PM_LEN_PLLD;
    uint16_t PFD_EN_DELAY_PLLD;
    uint32_t HSW_MEAS_SETTLE_PLLD;
    uint8_t HOLDEXIT_BW_SEL0_PLLD;
    uint8_t HOLD_FRZ_WITH_INTONLY_PLLD;
    uint8_t HOLD_RAMPBP_NOHIST_PLLD;
    uint8_t HOLDEXIT_BW0_PLLD;
    uint8_t HOLDEXIT_BW1_PLLD;
    uint8_t HOLDEXIT_BW2_PLLD;
    uint8_t HOLDEXIT_BW3_PLLD;
    uint8_t HOLDEXIT_BW4_PLLD;
    uint8_t HOLDEXIT_BW5_PLLD;
    uint8_t HSW_LIMIT_PLLD;
    uint8_t RAMP_STEP_SIZE_PLLD;
    uint8_t HOLD_SETTLE_DEN_EN_DSPLLD;
    uint8_t OUT_MAX_LIMIT_EN_PLLD;
    uint16_t OUT_MAX_LIMIT_LMT_PLLD;
    uint16_t HOLD_SETTLE_TARGET_DSPLLD;

    uint8_t FIXREGSD10;
    uint8_t FIXREGSD15;

    uint8_t FRACN_CLK_DIS_PLLC;
    uint8_t FRACN_CLK_DIS_PLLD;

    uint8_t IN_CLK_VAL_PWR_UP_DIS;
    uint8_t IN_CLK_VAL_EN_PLLC;
    uint8_t IN_CLK_VAL_TIME_PLLC;
    uint8_t IN_CLK_VAL_EN_PLLD;
    uint8_t IN_CLK_VAL_TIME_PLLD;

    if (FreqID0 == SI5397_IO_50M) {
        LOL_FST_EN_PLLC = 0; //..
        LOL_FST_DETWIN_SEL_PLLC = 0; //..
        LOL_FST_SET_THR_SEL_PLLC = 0; //..
        LOL_FST_CLR_THR_SEL_PLLC = 0; //..
        LOL_SLOW_EN_PLLC = 0; //..
        LOL_SLW_DETWIN_SEL_PLLC = 0; //..
        LOL_SLW_SET_THR_PLLC = 0; //..
        LOL_SLW_CLR_THR_PLLC = 0; //..
        FASTLOCK_EXTEND_PLLC = 0; //..
        OUT0_RDIV_FORCE2 = 1; //OUT0_RDIV_FORCE2 = 1 and then the R0_REG value is irrelevant.
        FASTLOCK_EXTEND_SCL_PLLC = 8;
        LOL_SLW_VALWIN_SELX_PLLC = 0;
        FASTLOCK_DLY_ONSW_EN_PLLC = 0;
        FASTLOCK_DLY_ONLOL_EN_PLLC = 0;
        FASTLOCK_DLY_ONLOL_PLLC = 0;
        FASTLOCK_DLY_ONSW_PLLC = 0;
        BW0_PLLC = 0;
        BW1_PLLC = 0;
        BW2_PLLC = 0;
        BW3_PLLC = 0;
        BW4_PLLC = 0;
        BW5_PLLC = 0;
        FASTLOCK_BW0_PLLC = 0;
        FASTLOCK_BW1_PLLC = 0;
        FASTLOCK_BW2_PLLC = 0;
        FASTLOCK_BW3_PLLC = 0;
        FASTLOCK_BW4_PLLC = 0;
        FASTLOCK_BW5_PLLC = 0;
        IN_SEL_PLLC = 0; //DSPC select input clock NUMBER (IN0~IN3)
        HOLD_RAMP_BYP_PLLC = 1;
        RAMP_STEP_INTERVAL_PLLC = 0;
        HOLD_HIST_LEN_PLLC = 0;
        HOLD_HIST_DELAY_PLLC = 0;
        HOLD_15M_CYC_COUNT_PLLC = 1024;
        FORCE_HOLD_PLLC = 1;
        CLK_SWITCH_MODE_PLLC = 2;
        HSW_COARSE_PM_LEN_PLLC = 10;
        HSW_COARSE_PM_DLY_PLLC = 6;
        HSW_FINE_PM_LEN_PLLC = 0;
        PFD_EN_DELAY_PLLC = 12;
        HOLDEXIT_BW_SEL0_PLLC = 0;
        HOLD_FRZ_WITH_INTONLY_PLLC = 0;
        HOLD_RAMPPB_NOHIST_PLLC = 0;
        HOLDEXIT_BW0_PLLC = 0;
        HOLDEXIT_BW1_PLLC = 0;
        HOLDEXIT_BW2_PLLC = 0;
        HOLDEXIT_BW3_PLLC = 0;
        HOLDEXIT_BW4_PLLC = 0;
        HOLDEXIT_BW5_PLLC = 0;
        HSW_LIMIT_PLLC = 32;
        RAMP_STEP_SIZE_PLLC = 0;
        OUT_MAX_LIMIT_EN_PLLC = 0;
        HOLD_SETTLE_DET_EN_DSPLLC = 0;
        HOLD_SETTLE_TARGET_DSPLLC = 0;
        IN_CLK_VAL_EN_PLLC = 0;
        IN_CLK_VAL_TIME_PLLC = 0;
    } else {
        LOL_FST_EN_PLLC = 1; //..
        LOL_FST_DETWIN_SEL_PLLC = 6; //..
        LOL_FST_SET_THR_SEL_PLLC = 8; //..
        LOL_FST_CLR_THR_SEL_PLLC = 6; //..
        LOL_SLOW_EN_PLLC = 1; //..
        LOL_SLW_DETWIN_SEL_PLLC = 3; //..
        LOL_SLW_SET_THR_PLLC = 4; //..
        LOL_SLW_CLR_THR_PLLC = 2; //..
        FASTLOCK_EXTEND_PLLC = 36066; //..
        OUT0_RDIV_FORCE2 = 0; //OUT0_RDIV_FORCE2 = 1 and then the R0_REG value is irrelevant.
        FASTLOCK_EXTEND_SCL_PLLC = 10;
        LOL_SLW_VALWIN_SELX_PLLC = 1;
        FASTLOCK_DLY_ONSW_EN_PLLC = 1;
        FASTLOCK_DLY_ONLOL_EN_PLLC = 1;
        FASTLOCK_DLY_ONLOL_PLLC = 3604;
        FASTLOCK_DLY_ONSW_PLLC = 4915;
        BW0_PLLC = 15;
        BW1_PLLC = 30;
        BW2_PLLC = 12;
        BW3_PLLC = 11;
        BW4_PLLC = 15;
        BW5_PLLC = 63;
        FASTLOCK_BW0_PLLC = 17;
        FASTLOCK_BW1_PLLC = 36;
        FASTLOCK_BW2_PLLC = 10;
        FASTLOCK_BW3_PLLC = 9;
        FASTLOCK_BW4_PLLC = 15;
        FASTLOCK_BW5_PLLC = 63;
        IN_SEL_PLLC = FreqID0 - SI5397_IO_IN0; //DSPC select input clock NUMBER (IN0~IN3)
        HOLD_RAMP_BYP_PLLC = 0;
        RAMP_STEP_INTERVAL_PLLC = 4;
        HOLD_HIST_LEN_PLLC = 25;
        HOLD_HIST_DELAY_PLLC = 25;
        HOLD_15M_CYC_COUNT_PLLC = 1667;
        FORCE_HOLD_PLLC = 0;
        CLK_SWITCH_MODE_PLLC = 0;
        HSW_COARSE_PM_LEN_PLLC = 4;
        HSW_COARSE_PM_DLY_PLLC = 2;
        HSW_FINE_PM_LEN_PLLC = 7;
        PFD_EN_DELAY_PLLC = 25;
        HOLDEXIT_BW_SEL0_PLLC = 1;
        HOLD_FRZ_WITH_INTONLY_PLLC = 1;
        HOLD_RAMPPB_NOHIST_PLLC = 1;
        HOLDEXIT_BW0_PLLC = 15;
        HOLDEXIT_BW1_PLLC = 32;
        HOLDEXIT_BW2_PLLC = 12;
        HOLDEXIT_BW3_PLLC = 11;
        HOLDEXIT_BW4_PLLC = 15;
        HOLDEXIT_BW5_PLLC = 63;
        HSW_LIMIT_PLLC = 8;
        RAMP_STEP_SIZE_PLLC = 3;
        OUT_MAX_LIMIT_EN_PLLC = 1;
        HOLD_SETTLE_DET_EN_DSPLLC = 1;
        HOLD_SETTLE_TARGET_DSPLLC = 51;
        IN_CLK_VAL_EN_PLLC = 1;
        IN_CLK_VAL_TIME_PLLC = 1;
    }
    switch (FreqID0) {
        case SI5397_IO_IN0:
        case SI5397_IO_IN2:
            LOL_CLR_DELAY_DIV256_PLLC = 36512;
            R0_REG = 11;
            N2_NUM = 61865984000;
            N2_DEN = 3221225472;
            M_NUM_PLLC = 2473901162496;
            M_DEN_PLLC = 3355443200;
            M_FRAC_EN_PLLC = 1;
            HSW_MEAS_SETTLE_PLLC = 12676;
            OUT_MAX_LIMIT_LMT_DPSLLC = 20138;
            FRACN_CLK_DIS_PLLC = 0;
            break;
        case SI5397_IO_IN1:
            LOL_CLR_DELAY_DIV256_PLLC = 36503;
            R0_REG = 11;
            N2_NUM = 63350767616;
            N2_DEN = 3355443200;
            M_NUM_PLLC = 1610612736000;
            M_DEN_PLLC = 2147483648;
            M_FRAC_EN_PLLC = 0;
            HSW_MEAS_SETTLE_PLLC = 12414;
            OUT_MAX_LIMIT_LMT_DPSLLC = 19797;
            FRACN_CLK_DIS_PLLC = 1;
            break;
        case SI5397_IO_IN3:
            LOL_CLR_DELAY_DIV256_PLLC = 36510;
            R0_REG = 36;
            N2_NUM = 47513075712;
            N2_DEN = 2483027968;
            M_NUM_PLLC = 1589137899520;
            M_DEN_PLLC = 2147483648;
            M_FRAC_EN_PLLC = 0;
            HSW_MEAS_SETTLE_PLLC = 12619;
            OUT_MAX_LIMIT_LMT_DPSLLC = 20064;
            FRACN_CLK_DIS_PLLC = 1;
            break;
        case SI5397_IO_50M:
        default:
            LOL_CLR_DELAY_DIV256_PLLC = 0;
            R0_REG = 0;
            N2_NUM = 304083684557;
            N2_DEN = 2147483648;
            M_NUM_PLLC = 0;
            M_DEN_PLLC = 0;
            M_FRAC_EN_PLLC = 0;
            HSW_MEAS_SETTLE_PLLC = 0;
            OUT_MAX_LIMIT_LMT_DPSLLC = 0;
            FRACN_CLK_DIS_PLLC = 0;
            break;
    }


    if (FreqID4 == SI5397_IO_50M) {
        LOL_FST_EN_PLLD = 0; //..
        LOL_FST_DETWIN_SEL_PLLD = 0; //..
        LOL_FST_SET_THR_SEL_PLLD = 0; //..
        LOL_FST_CLR_THR_SEL_PLLD = 0; //..
        LOL_SLOW_EN_PLLD = 0; //..
        LOL_SLW_DETWIN_SEL_PLLD = 0; //..
        LOL_SLW_SET_THR_PLLD = 0; //..
        LOL_SLW_CLR_THR_PLLD = 0; //..
        FASTLOCK_EXTEND_PLLD = 0; //..
        OUT4_RDIV_FORCE2 = 1; //OUT4_RDIV_FORCE2 = 1 and then the R0_REG value is irrelevant.1 ;
        FASTLOCK_EXTEND_SCL_PLLD = 8;
        LOL_SLW_VALWIN_SELX_PLLD = 0;
        FASTLOCK_DLY_ONSW_EN_PLLD = 0;
        FASTLOCK_DLY_ONLOL_EN_PLLD = 0;
        FASTLOCK_DLY_ONLOL_PLLD = 0;
        FASTLOCK_DLY_ONSW_PLLD = 0;
        BW0_PLLD = 0;
        BW1_PLLD = 0;
        BW2_PLLD = 0;
        BW3_PLLD = 0;
        BW4_PLLD = 0;
        BW5_PLLD = 0;
        FASTLOCK_BW0_PLLD = 0;
        FASTLOCK_BW1_PLLD = 0;
        FASTLOCK_BW2_PLLD = 0;
        FASTLOCK_BW3_PLLD = 0;
        FASTLOCK_BW4_PLLD = 0;
        FASTLOCK_BW5_PLLD = 0;
        IN_SEL_PLLD = 0;
        HOLD_RAMP_BYP_PLLD = 1;
        RAMP_STEP_INTERVAL_PLLD = 0;
        HOLD_HIST_LEN_PLLD = 0;
        HOLD_HIST_DELAY_PLLD = 0;
        HOLD_15M_CYC_COUNT_PLLD = 1024;
        FORCE_HOLD_PLLD = 1;
        CLK_SWITCH_MODE_PLLD = 2;
        HSW_COARSE_PM_LEN_PLLD = 10;
        HSW_COARSE_PM_DLY_PLLD = 6;
        HSW_FINE_PM_LEN_PLLD = 0;
        PFD_EN_DELAY_PLLD = 12;
        HOLDEXIT_BW_SEL0_PLLD = 0;
        HOLD_FRZ_WITH_INTONLY_PLLD = 0;
        HOLD_RAMPBP_NOHIST_PLLD = 0;
        HOLDEXIT_BW0_PLLD = 0;
        HOLDEXIT_BW1_PLLD = 0;
        HOLDEXIT_BW2_PLLD = 0;
        HOLDEXIT_BW3_PLLD = 0;
        HOLDEXIT_BW4_PLLD = 0;
        HOLDEXIT_BW5_PLLD = 0;
        HSW_LIMIT_PLLD = 32;
        RAMP_STEP_SIZE_PLLD = 0;
        HOLD_SETTLE_DEN_EN_DSPLLD = 0;
        OUT_MAX_LIMIT_EN_PLLD = 0;
        HOLD_SETTLE_TARGET_DSPLLD = 0;
        IN_CLK_VAL_EN_PLLD = 0;
        IN_CLK_VAL_TIME_PLLD = 0;
    } else {
        LOL_FST_EN_PLLD = 1; //..
        LOL_FST_DETWIN_SEL_PLLD = 6; //..
        LOL_FST_SET_THR_SEL_PLLD = 8; //..
        LOL_FST_CLR_THR_SEL_PLLD = 6; //..
        LOL_SLOW_EN_PLLD = 1; //..
        LOL_SLW_DETWIN_SEL_PLLD = 3; //..
        LOL_SLW_SET_THR_PLLD = 4; //..
        LOL_SLW_CLR_THR_PLLD = 2; //..
        FASTLOCK_EXTEND_PLLD = 36066; //..
        OUT4_RDIV_FORCE2 = 0; //OUT4_RDIV_FORCE2 = 1 and then the R0_REG value is irrelevant.1 ;
        FASTLOCK_EXTEND_SCL_PLLD = 10;
        LOL_SLW_VALWIN_SELX_PLLD = 1;
        FASTLOCK_DLY_ONSW_EN_PLLD = 1;
        FASTLOCK_DLY_ONLOL_EN_PLLD = 1;
        FASTLOCK_DLY_ONLOL_PLLD = 3604;
        FASTLOCK_DLY_ONSW_PLLD = 4915;
        BW0_PLLD = 15;
        BW1_PLLD = 30;
        BW2_PLLD = 12;
        BW3_PLLD = 11;
        BW4_PLLD = 15;
        BW5_PLLD = 63;
        FASTLOCK_BW0_PLLD = 17;
        FASTLOCK_BW1_PLLD = 36;
        FASTLOCK_BW2_PLLD = 10;
        FASTLOCK_BW3_PLLD = 9;
        FASTLOCK_BW4_PLLD = 15;
        FASTLOCK_BW5_PLLD = 63;
        IN_SEL_PLLD = FreqID4 - SI5397_IO_IN0;
        HOLD_RAMP_BYP_PLLD = 0;
        RAMP_STEP_INTERVAL_PLLD = 4;
        HOLD_HIST_LEN_PLLD = 25;
        HOLD_HIST_DELAY_PLLD = 25;
        HOLD_15M_CYC_COUNT_PLLD = 1667;
        FORCE_HOLD_PLLD = 0;
        CLK_SWITCH_MODE_PLLD = 0;
        HSW_COARSE_PM_LEN_PLLD = 4;
        HSW_COARSE_PM_DLY_PLLD = 2;
        HSW_FINE_PM_LEN_PLLD = 7;
        PFD_EN_DELAY_PLLD = 25;
        HOLDEXIT_BW_SEL0_PLLD = 1;
        HOLD_FRZ_WITH_INTONLY_PLLD = 1;
        HOLD_RAMPBP_NOHIST_PLLD = 1;
        HOLDEXIT_BW0_PLLD = 15;
        HOLDEXIT_BW1_PLLD = 32;
        HOLDEXIT_BW2_PLLD = 12;
        HOLDEXIT_BW3_PLLD = 11;
        HOLDEXIT_BW4_PLLD = 15;
        HOLDEXIT_BW5_PLLD = 63;
        HSW_LIMIT_PLLD = 8;
        RAMP_STEP_SIZE_PLLD = 3;
        HOLD_SETTLE_DEN_EN_DSPLLD = 1;
        OUT_MAX_LIMIT_EN_PLLD = 1;
        HOLD_SETTLE_TARGET_DSPLLD = 50;
        IN_CLK_VAL_EN_PLLD = 1;
        IN_CLK_VAL_TIME_PLLD = 1;
    }
    switch (FreqID4) {
        case SI5397_IO_IN0:
        case SI5397_IO_IN2:
            LOL_CLR_DELAY_DIV256_PLLD = 36512;
            R4_REG = 11;
            N3_NUM = 61865984000;
            N3_DEN = 3221225472;
            M_NUM_PLLD = 2473901162496;
            M_DEN_PLLD = 3355443200;
            M_FRAC_EN_PLLD = 1;
            HSW_MEAS_SETTLE_PLLD = 12676;
            OUT_MAX_LIMIT_LMT_PLLD = 20138;
            FRACN_CLK_DIS_PLLD = 0;
            break;
        case SI5397_IO_IN1:
            LOL_CLR_DELAY_DIV256_PLLD = 36503;
            R4_REG = 11;
            N3_NUM = 63350767616;
            N3_DEN = 3355443200;
            M_NUM_PLLD = 1610612736000;
            M_DEN_PLLD = 2147483648;
            M_FRAC_EN_PLLD = 0;
            HSW_MEAS_SETTLE_PLLD = 12414;
            OUT_MAX_LIMIT_LMT_PLLD = 19797;
            FRACN_CLK_DIS_PLLD = 1;
            break;
        case SI5397_IO_IN3:
            LOL_CLR_DELAY_DIV256_PLLD = 36510;
            R4_REG = 36;
            N3_NUM = 47513075712;
            N3_DEN = 2483027968;
            M_NUM_PLLD = 1589137899520;
            M_DEN_PLLD = 2147483648;
            M_FRAC_EN_PLLD = 0;
            HSW_MEAS_SETTLE_PLLD = 12619;
            OUT_MAX_LIMIT_LMT_PLLD = 20064;
            FRACN_CLK_DIS_PLLD = 1;
            break;
        case SI5397_IO_50M:
        default:
            LOL_CLR_DELAY_DIV256_PLLD = 0;
            R4_REG = 0;
            N3_NUM = 304083684557;
            N3_DEN = 2147483648;
            M_NUM_PLLD = 0;
            M_DEN_PLLD = 0;
            M_FRAC_EN_PLLD = 0;
            HSW_MEAS_SETTLE_PLLD = 0;
            OUT_MAX_LIMIT_LMT_PLLD = 0;
            FRACN_CLK_DIS_PLLD = 0;
            break;
    }

    // ========
    uint64_t Nx_NUM[2];
    SI5397A_FREQ_ID FreqIDx[2] = {FreqID2, FreqID6};
    for (int i = 0; i < 2; i++) {
        switch (FreqIDx[i]) {
            case SI5397_XCVR_644M53125:
                Nx_NUM[i] = 23589522196;
                break;
            case SI5397_XCVR_625M:
                Nx_NUM[i] = 24326694765;
                break;
            case SI5397_XCVR_322M265625:
                Nx_NUM[i] = 47179044392;
                break;
            case SI5397_XCVR_312M5:
                Nx_NUM[i] = 48653389529;
                break;
            case SI5397_XCVR_307M2:
                Nx_NUM[i] = 49492787200;
                break;
            case SI5397_XCVR_250M:
                Nx_NUM[i] = 60816736911;
                break;
            case SI5397_XCVR_184M32:
                Nx_NUM[i] = 82487978667;
                break;
            case SI5397_XCVR_156M25:
                Nx_NUM[i] = 97306779058;
                break;
            case SI5397_XCVR_153M6:
                Nx_NUM[i] = 98985574400;
                break;
            case SI5397_XCVR_125M:
                Nx_NUM[i] = 121633473823;
                break;
            case SI5397_XCVR_100M:
                Nx_NUM[i] = 152041842278;
                break;
            default:
                Nx_NUM[i] = 0;
                break;
        }
    }
    N0_NUM = Nx_NUM[0];
    N1_NUM = Nx_NUM[1];

    if (FreqID0 == SI5397_IO_50M || FreqID4 == SI5397_IO_50M) {
        IN_CLK_VAL_PWR_UP_DIS = 0;
        FIXREGSD10 = 1;
        FIXREGSD15 = 1;
    } else {
        IN_CLK_VAL_PWR_UP_DIS = 15;
        FIXREGSD10 = 0;
        FIXREGSD15 = 0;
    }

    if (FreqID7 == FreqID6 && FreqID7 != SI5397_XCVR_NONE) {
        OUT7_OE = 1;
    } else {
        OUT7_OE = 0;
    }

    si5397_register_t const si5397_registers_preamble[] = {
        /* Start configuration preamble */
        {REGA_ADDR_PAGE, 0xB},
        { 0x24, 0xC0 },
        { 0x25, 0x00 },
        /* End configuration preamble */
    };
    si5397_register_t const si5397_registers_postamble[] = {
        /* Start configuration postamble */
        {REGA_ADDR_PAGE, 0x0},
        { 0x1C, 0x01 },
        {REGA_ADDR_PAGE, 0xB},
        { 0x24, 0xC3 },
        { 0x25, 0x02 },
        /* End configuration postamble */
    };
    si5397_register_t const si5397_registers[] = {
        {REGA_ADDR_PAGE, 0x0},
        {REGA_ADDR_0018, REG_0018},
        {REGA_ADDR_0019, REG_0019},
        {REGA_ADDR_001A, REG_001A},
        {REGA_ADDR_002C, REG_002C},
        {REGA_ADDR_002E, REG_002E},
        {REGA_ADDR_002F, REG_002F},
        {REGA_ADDR_0030, REG_0030},
        {REGA_ADDR_0031, REG_0031},
        {REGA_ADDR_0032, REG_0032},
        {REGA_ADDR_0033, REG_0033},
        {REGA_ADDR_0034, REG_0034},
        {REGA_ADDR_0035, REG_0035},
        {REGA_ADDR_0036, REG_0036},
        {REGA_ADDR_0037, REG_0037},
        {REGA_ADDR_0038, REG_0038},
        {REGA_ADDR_0039, REG_0039},
        {REGA_ADDR_003A, REG_003A},
        {REGA_ADDR_003B, REG_003B},
        {REGA_ADDR_003C, REG_003C},
        {REGA_ADDR_003D, REG_003D},
        {REGA_ADDR_003E, REG_003E},
        {REGA_ADDR_003F, REG_003F},
        {REGA_ADDR_0040, REG_0040},
        {REGA_ADDR_0041, REG_0041},
        {REGA_ADDR_0042, REG_0042},
        {REGA_ADDR_0043, REG_0043},
        {REGA_ADDR_0044, REG_0044},
        {REGA_ADDR_0046, REG_0046},
        {REGA_ADDR_0047, REG_0047},
        {REGA_ADDR_0048, REG_0048},
        {REGA_ADDR_0049, REG_0049},
        {REGA_ADDR_004A, REG_004A},
        {REGA_ADDR_004B, REG_004B},
        {REGA_ADDR_004C, REG_004C},
        {REGA_ADDR_004D, REG_004D},
        {REGA_ADDR_004E, REG_004E},
        {REGA_ADDR_004F, REG_004F},
        {REGA_ADDR_0050, REG_0050},
        {REGA_ADDR_0051, REG_0051},
        {REGA_ADDR_0052, REG_0052},
        {REGA_ADDR_0053, REG_0053},
        {REGA_ADDR_0054, REG_0054},
        {REGA_ADDR_0055, REG_0055},
        {REGA_ADDR_0056, REG_0056},
        {REGA_ADDR_0057, REG_0057},
        {REGA_ADDR_0058, REG_0058},
        {REGA_ADDR_0059, REG_0059},
        {REGA_ADDR_005A, REG_005A},
        {REGA_ADDR_005B, REG_005B},
        {REGA_ADDR_005C, REG_005C},
        {REGA_ADDR_005D, REG_005D},
        {REGA_ADDR_005E, REG_005E},
        {REGA_ADDR_005F, REG_005F},
        {REGA_ADDR_0060, REG_0060},
        {REGA_ADDR_0061, REG_0061},
        {REGA_ADDR_0062, REG_0062},
        {REGA_ADDR_0063, REG_0063},
        {REGA_ADDR_0064, REG_0064},
        {REGA_ADDR_0065, REG_0065},
        {REGA_ADDR_0066, REG_0066},
        {REGA_ADDR_0067, REG_0067},
        {REGA_ADDR_0068, REG_0068},
        {REGA_ADDR_0069, REG_0069},
        {REGA_ADDR_0092, REG_0092},
        {REGA_ADDR_0094, REG_0094},
        {REGA_ADDR_0097, REG_0097},
        {REGA_ADDR_0099, REG_0099},
        {REGA_ADDR_009A, REG_009A},
        {REGA_ADDR_009C, REG_009C},
        {REGA_ADDR_009D, REG_009D},
        {REGA_ADDR_009F, REG_009F},
        {REGA_ADDR_00A1, REG_00A1},
        {REGA_ADDR_00AE, REG_00AE},
        {REGA_ADDR_00AF, REG_00AF},
        {REGA_ADDR_00B0, REG_00B0},
        {REGA_ADDR_00B1, REG_00B1},
        {REGA_ADDR_00B3, REG_00B3},
        {REGA_ADDR_00B4, REG_00B4},
        {REGA_ADDR_00B5, REG_00B5},
        {REGA_ADDR_00B6, REG_00B6},
        {REGA_ADDR_00EE, REG_00EE},
        {REGA_ADDR_00EF, REG_00EF},
        {REGA_ADDR_00F0, REG_00F0},
        {REGA_ADDR_00F1, REG_00F1},
        {REGA_ADDR_00F2, REG_00F2},
        {REGA_ADDR_00F3, REG_00F3},
        {REGA_ADDR_00F4, REG_00F4},
        {REGA_ADDR_00F5, REG_00F5},
        {REGA_ADDR_PAGE, 0x1},
        {REGA_ADDR_0108, REG_0108},
        {REGA_ADDR_010B, REG_010B},
        {REGA_ADDR_0117, REG_0117},
        {REGA_ADDR_011A, REG_011A},
        {REGA_ADDR_0126, REG_0126},
        {REGA_ADDR_0129, REG_0129},
        {REGA_ADDR_0130, REG_0130},
        {REGA_ADDR_0133, REG_0133},
        {REGA_ADDR_013A, REG_013A},
        {REGA_ADDR_013D, REG_013D},
        {REGA_ADDR_PAGE, 0x2},
        {REGA_ADDR_0206, REG_0206},
        {REGA_ADDR_0208, REG_0208},
        {REGA_ADDR_0209, REG_0209},
        {REGA_ADDR_020A, REG_020A},
        {REGA_ADDR_020B, REG_020B},
        {REGA_ADDR_020C, REG_020C},
        {REGA_ADDR_020D, REG_020D},
        {REGA_ADDR_020E, REG_020E},
        {REGA_ADDR_020F, REG_020F},
        {REGA_ADDR_0210, REG_0210},
        {REGA_ADDR_0211, REG_0211},
        {REGA_ADDR_0212, REG_0212},
        {REGA_ADDR_0213, REG_0213},
        {REGA_ADDR_0214, REG_0214},
        {REGA_ADDR_0215, REG_0215},
        {REGA_ADDR_0216, REG_0216},
        {REGA_ADDR_0217, REG_0217},
        {REGA_ADDR_0218, REG_0218},
        {REGA_ADDR_0219, REG_0219},
        {REGA_ADDR_021A, REG_021A},
        {REGA_ADDR_021B, REG_021B},
        {REGA_ADDR_021C, REG_021C},
        {REGA_ADDR_021D, REG_021D},
        {REGA_ADDR_021E, REG_021E},
        {REGA_ADDR_021F, REG_021F},
        {REGA_ADDR_0220, REG_0220},
        {REGA_ADDR_0221, REG_0221},
        {REGA_ADDR_0222, REG_0222},
        {REGA_ADDR_0223, REG_0223},
        {REGA_ADDR_0224, REG_0224},
        {REGA_ADDR_0225, REG_0225},
        {REGA_ADDR_0226, REG_0226},
        {REGA_ADDR_0227, REG_0227},
        {REGA_ADDR_0228, REG_0228},
        {REGA_ADDR_0229, REG_0229},
        {REGA_ADDR_022A, REG_022A},
        {REGA_ADDR_022B, REG_022B},
        {REGA_ADDR_022C, REG_022C},
        {REGA_ADDR_022D, REG_022D},
        {REGA_ADDR_022E, REG_022E},
        {REGA_ADDR_022F, REG_022F},
        {REGA_ADDR_0230, REG_0230},
        {REGA_ADDR_0231, REG_0231},
        {REGA_ADDR_0232, REG_0232},
        {REGA_ADDR_0233, REG_0233},
        {REGA_ADDR_0234, REG_0234},
        {REGA_ADDR_0235, REG_0235},
        {REGA_ADDR_0236, REG_0236},
        {REGA_ADDR_0237, REG_0237},
        {REGA_ADDR_0238, REG_0238},
        {REGA_ADDR_0239, REG_0239},
        {REGA_ADDR_023A, REG_023A},
        {REGA_ADDR_023B, REG_023B},
        {REGA_ADDR_023C, REG_023C},
        {REGA_ADDR_023D, REG_023D},
        {REGA_ADDR_023E, REG_023E},
        {REGA_ADDR_023F, REG_023F},
        {REGA_ADDR_024A, REG_024A},
        {REGA_ADDR_024B, REG_024B},
        {REGA_ADDR_024C, REG_024C},
        {REGA_ADDR_0253, REG_0253},
        {REGA_ADDR_0254, REG_0254},
        {REGA_ADDR_0255, REG_0255},
        {REGA_ADDR_025C, REG_025C},
        {REGA_ADDR_025D, REG_025D},
        {REGA_ADDR_025E, REG_025E},
        {REGA_ADDR_0262, REG_0262},
        {REGA_ADDR_0263, REG_0263},
        {REGA_ADDR_0264, REG_0264},
        {REGA_ADDR_0268, REG_0268},
        {REGA_ADDR_0269, REG_0269},
        {REGA_ADDR_026A, REG_026A},
        {REGA_ADDR_0292, REG_0292},
        {REGA_ADDR_0293, REG_0293},
        {REGA_ADDR_0295, REG_0295},
        {REGA_ADDR_0296, REG_0296},
        {REGA_ADDR_0297, REG_0297},
        {REGA_ADDR_0299, REG_0299},
        {REGA_ADDR_02A0, REG_02A0},
        {REGA_ADDR_02A1, REG_02A1},
        {REGA_ADDR_02A2, REG_02A2},
        {REGA_ADDR_02A3, REG_02A3},
        {REGA_ADDR_02A4, REG_02A4},
        {REGA_ADDR_02A5, REG_02A5},
        {REGA_ADDR_02AC, REG_02AC},
        {REGA_ADDR_02AD, REG_02AD},
        {REGA_ADDR_02AE, REG_02AE},
        {REGA_ADDR_02AF, REG_02AF},
        {REGA_ADDR_02B0, REG_02B0},
        {REGA_ADDR_02B1, REG_02B1},
        {REGA_ADDR_PAGE, 0x3},
        {REGA_ADDR_0302, REG_0302},
        {REGA_ADDR_0303, REG_0303},
        {REGA_ADDR_0304, REG_0304},
        {REGA_ADDR_0305, REG_0305},
        {REGA_ADDR_0306, REG_0306},
        {REGA_ADDR_0307, REG_0307},
        {REGA_ADDR_0308, REG_0308},
        {REGA_ADDR_0309, REG_0309},
        {REGA_ADDR_030A, REG_030A},
        {REGA_ADDR_030B, REG_030B},
        {REGA_ADDR_030C, REG_030C},
        {REGA_ADDR_030D, REG_030D},
        {REGA_ADDR_030E, REG_030E},
        {REGA_ADDR_030F, REG_030F},
        {REGA_ADDR_0310, REG_0310},
        {REGA_ADDR_0311, REG_0311},
        {REGA_ADDR_0312, REG_0312},
        {REGA_ADDR_0313, REG_0313},
        {REGA_ADDR_0314, REG_0314},
        {REGA_ADDR_0315, REG_0315},
        {REGA_ADDR_0316, REG_0316},
        {REGA_ADDR_0317, REG_0317},
        {REGA_ADDR_0318, REG_0318},
        {REGA_ADDR_0319, REG_0319},
        {REGA_ADDR_031A, REG_031A},
        {REGA_ADDR_031B, REG_031B},
        {REGA_ADDR_031C, REG_031C},
        {REGA_ADDR_031D, REG_031D},
        {REGA_ADDR_031E, REG_031E},
        {REGA_ADDR_031F, REG_031F},
        {REGA_ADDR_0320, REG_0320},
        {REGA_ADDR_0321, REG_0321},
        {REGA_ADDR_0322, REG_0322},
        {REGA_ADDR_0323, REG_0323},
        {REGA_ADDR_0324, REG_0324},
        {REGA_ADDR_0325, REG_0325},
        {REGA_ADDR_0326, REG_0326},
        {REGA_ADDR_0327, REG_0327},
        {REGA_ADDR_0328, REG_0328},
        {REGA_ADDR_0329, REG_0329},
        {REGA_ADDR_032A, REG_032A},
        {REGA_ADDR_032B, REG_032B},
        {REGA_ADDR_032C, REG_032C},
        {REGA_ADDR_032D, REG_032D},
        {REGA_ADDR_0338, REG_0338},
        {REGA_ADDR_PAGE, 0x4},
        {REGA_ADDR_0420, REG_0420},
        {REGA_ADDR_PAGE, 0x5},
        {REGA_ADDR_0520, REG_0520},
        {REGA_ADDR_PAGE, 0x6},
        {REGA_ADDR_0608, REG_0608},
        {REGA_ADDR_0609, REG_0609},
        {REGA_ADDR_060A, REG_060A},
        {REGA_ADDR_060B, REG_060B},
        {REGA_ADDR_060C, REG_060C},
        {REGA_ADDR_060D, REG_060D},
        {REGA_ADDR_060E, REG_060E},
        {REGA_ADDR_060F, REG_060F},
        {REGA_ADDR_0610, REG_0610},
        {REGA_ADDR_0611, REG_0611},
        {REGA_ADDR_0612, REG_0612},
        {REGA_ADDR_0613, REG_0613},
        {REGA_ADDR_0614, REG_0614},
        {REGA_ADDR_0615, REG_0615},
        {REGA_ADDR_0616, REG_0616},
        {REGA_ADDR_0617, REG_0617},
        {REGA_ADDR_0618, REG_0618},
        {REGA_ADDR_0619, REG_0619},
        {REGA_ADDR_061A, REG_061A},
        {REGA_ADDR_061B, REG_061B},
        {REGA_ADDR_061C, REG_061C},
        {REGA_ADDR_061D, REG_061D},
        {REGA_ADDR_061E, REG_061E},
        {REGA_ADDR_061F, REG_061F},
        {REGA_ADDR_0620, REG_0620},
        {REGA_ADDR_0621, REG_0621},
        {REGA_ADDR_0622, REG_0622},
        {REGA_ADDR_0623, REG_0623},
        {REGA_ADDR_0624, REG_0624},
        {REGA_ADDR_0625, REG_0625},
        {REGA_ADDR_0626, REG_0626},
        {REGA_ADDR_0627, REG_0627},
        {REGA_ADDR_0628, REG_0628},
        {REGA_ADDR_0629, REG_0629},
        {REGA_ADDR_062A, REG_062A},
        {REGA_ADDR_062B, REG_062B},
        {REGA_ADDR_062C, REG_062C},
        {REGA_ADDR_062E, REG_062E},
        {REGA_ADDR_062F, REG_062F},
        {REGA_ADDR_0632, REG_0632},
        {REGA_ADDR_0633, REG_0633},
        {REGA_ADDR_0634, REG_0634},
        {REGA_ADDR_0635, REG_0635},
        {REGA_ADDR_0636, REG_0636},
        {REGA_ADDR_063A, REG_063A},
        {REGA_ADDR_063B, REG_063B},
        {REGA_ADDR_063C, REG_063C},
        {REGA_ADDR_063D, REG_063D},
        {REGA_ADDR_063E, REG_063E},
        {REGA_ADDR_0688, REG_0688},
        {REGA_ADDR_0689, REG_0689},
        {REGA_ADDR_068A, REG_068A},
        {REGA_ADDR_068B, REG_068B},
        {REGA_ADDR_068C, REG_068C},
        {REGA_ADDR_068D, REG_068D},
        {REGA_ADDR_069B, REG_069B},
        {REGA_ADDR_069C, REG_069C},
        {REGA_ADDR_069D, REG_069D},
        {REGA_ADDR_069E, REG_069E},
        {REGA_ADDR_069F, REG_069F},
        {REGA_ADDR_06A0, REG_06A0},
        {REGA_ADDR_06A1, REG_06A1},
        {REGA_ADDR_06A2, REG_06A2},
        {REGA_ADDR_06A4, REG_06A4},
        {REGA_ADDR_06A5, REG_06A5},
        {REGA_ADDR_06A6, REG_06A6},
        {REGA_ADDR_06AC, REG_06AC},
        {REGA_ADDR_06AD, REG_06AD},
        {REGA_ADDR_06AE, REG_06AE},
        {REGA_ADDR_06B1, REG_06B1},
        {REGA_ADDR_06B2, REG_06B2},
        {REGA_ADDR_PAGE, 0x7},
        {REGA_ADDR_0709, REG_0709},
        {REGA_ADDR_070A, REG_070A},
        {REGA_ADDR_070B, REG_070B},
        {REGA_ADDR_070C, REG_070C},
        {REGA_ADDR_070D, REG_070D},
        {REGA_ADDR_070E, REG_070E},
        {REGA_ADDR_070F, REG_070F},
        {REGA_ADDR_0710, REG_0710},
        {REGA_ADDR_0711, REG_0711},
        {REGA_ADDR_0712, REG_0712},
        {REGA_ADDR_0713, REG_0713},
        {REGA_ADDR_0714, REG_0714},
        {REGA_ADDR_0715, REG_0715},
        {REGA_ADDR_0716, REG_0716},
        {REGA_ADDR_0717, REG_0717},
        {REGA_ADDR_0718, REG_0718},
        {REGA_ADDR_0719, REG_0719},
        {REGA_ADDR_071A, REG_071A},
        {REGA_ADDR_071B, REG_071B},
        {REGA_ADDR_071C, REG_071C},
        {REGA_ADDR_071D, REG_071D},
        {REGA_ADDR_071E, REG_071E},
        {REGA_ADDR_071F, REG_071F},
        {REGA_ADDR_0720, REG_0720},
        {REGA_ADDR_0721, REG_0721},
        {REGA_ADDR_0722, REG_0722},
        {REGA_ADDR_0723, REG_0723},
        {REGA_ADDR_0724, REG_0724},
        {REGA_ADDR_0725, REG_0725},
        {REGA_ADDR_0726, REG_0726},
        {REGA_ADDR_0727, REG_0727},
        {REGA_ADDR_0728, REG_0728},
        {REGA_ADDR_0729, REG_0729},
        {REGA_ADDR_072A, REG_072A},
        {REGA_ADDR_072B, REG_072B},
        {REGA_ADDR_072C, REG_072C},
        {REGA_ADDR_072D, REG_072D},
        {REGA_ADDR_072F, REG_072F},
        {REGA_ADDR_0730, REG_0730},
        {REGA_ADDR_0733, REG_0733},
        {REGA_ADDR_0734, REG_0734},
        {REGA_ADDR_0735, REG_0735},
        {REGA_ADDR_0736, REG_0736},
        {REGA_ADDR_0737, REG_0737},
        {REGA_ADDR_073B, REG_073B},
        {REGA_ADDR_073C, REG_073C},
        {REGA_ADDR_073D, REG_073D},
        {REGA_ADDR_073E, REG_073E},
        {REGA_ADDR_073F, REG_073F},
        {REGA_ADDR_0788, REG_0788},
        {REGA_ADDR_0789, REG_0789},
        {REGA_ADDR_078A, REG_078A},
        {REGA_ADDR_078B, REG_078B},
        {REGA_ADDR_078C, REG_078C},
        {REGA_ADDR_078D, REG_078D},
        {REGA_ADDR_079B, REG_079B},
        {REGA_ADDR_079C, REG_079C},
        {REGA_ADDR_079D, REG_079D},
        {REGA_ADDR_079E, REG_079E},
        {REGA_ADDR_079F, REG_079F},
        {REGA_ADDR_07A0, REG_07A0},
        {REGA_ADDR_07A1, REG_07A1},
        {REGA_ADDR_07A2, REG_07A2},
        {REGA_ADDR_07A4, REG_07A4},
        {REGA_ADDR_07A5, REG_07A5},
        {REGA_ADDR_07A6, REG_07A6},
        {REGA_ADDR_07AC, REG_07AC},
        {REGA_ADDR_07AD, REG_07AD},
        {REGA_ADDR_07AE, REG_07AE},
        {REGA_ADDR_07B1, REG_07B1},
        {REGA_ADDR_07B2, REG_07B2},
        {REGA_ADDR_PAGE, 0x8},
        {REGA_ADDR_0822, REG_0822},
        {REGA_ADDR_0831, REG_0831},
        {REGA_ADDR_PAGE, 0x9},
        {REGA_ADDR_090E, REG_090E},
        {REGA_ADDR_0949, REG_0949},
        {REGA_ADDR_094A, REG_094A},
        {REGA_ADDR_PAGE, 0xB},
        {REGA_ADDR_0B44, REG_0B44},
        {REGA_ADDR_0B47, REG_0B47},
        {REGA_ADDR_0B48, REG_0B48},
        {REGA_ADDR_PAGE, 0xC},
        {REGA_ADDR_0C03, REG_0C03},
        {REGA_ADDR_0C09, REG_0C09},
        {REGA_ADDR_0C0A, REG_0C0A},
        {REGA_ADDR_0C0B, REG_0C0B},
        {REGA_ADDR_0C0C, REG_0C0C},
    };

    size_t config_num_regs = sizeof(si5397_registers_preamble) / sizeof(si5397_register_t);
    for (int i = 0; i < config_num_regs; i++) {
        if (bSuccess)
            bSuccess = SI5397A_w_reg(i2c_base, si5397_registers_preamble[i].address, si5397_registers_preamble[i].value);
    }
	/* Delay 300 msec */
	/*    Delay is worst case time for device to complete any calibration */
	/*    that is running due to device state change previous to this script */
	/*    being processed. */
    usleep(300 * 1000);
    config_num_regs = sizeof(si5397_registers) / sizeof(si5397_register_t);
    for (int i = 0; i < config_num_regs; i++) {
        if (bSuccess)
            bSuccess = SI5397A_w_reg(i2c_base, si5397_registers[i].address, si5397_registers[i].value);
    }
    config_num_regs = sizeof(si5397_registers_postamble) / sizeof(si5397_register_t);
    for (int i = 0; i < config_num_regs; i++) {
        if (bSuccess)
            bSuccess = SI5397A_w_reg(i2c_base, si5397_registers_postamble[i].address, si5397_registers_postamble[i].value);
    }

    return bSuccess;
}

bool SI5397A_Status(uint32_t i2c_base)
{
    bool bSuccess = TRUE;
    uint8_t dataR;
    uint8_t los, oof, lol;

    if (bSuccess)
        bSuccess = SI5397A_w_reg(i2c_base, REGA_ADDR_PAGE, 0x00); // Page  0

    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_000D, &dataR); // OOF, LOS
    if (bSuccess){
        los = (dataR >> 0) & 0xf;
        oof = (dataR >> 4) & 0xf;
    }

    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_000E, &dataR); // HOLD_PLL, LOL_PLL
    if (bSuccess){
        lol = (dataR >> 0) & 0xf;
    }

    uint8_t in_sel_pllc, in_sel_plld;
    uint8_t free_run_c = 0, free_run_d = 0;

    if (bSuccess)
        bSuccess = SI5397A_w_reg(i2c_base, REGA_ADDR_PAGE, 0x06); // Page  6
    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_062A, &dataR); // 5'h0, IN_SEL_PLLC[2: 0]
    if (bSuccess){
        in_sel_pllc = (dataR >> 0) & 0x7;
    }
    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_0619, &dataR); // M_NUM_PLLC[39:32]
    if (bSuccess && dataR == 0){
        free_run_c = 1;
    }
    if (bSuccess)
        bSuccess = SI5397A_w_reg(i2c_base, REGA_ADDR_PAGE, 0x07); // Page  7
    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_072B, &dataR); // 5'h0, IN_SEL_PLLD[2: 0]
    if (bSuccess){
        in_sel_plld = (dataR >> 0) & 0x7;
    }
    if (bSuccess)
        bSuccess = SI5397A_r_reg(i2c_base, REGA_ADDR_071A, &dataR); // M_NUM_PLLD[39:32]
    if (bSuccess && dataR == 0){
        free_run_d = 1;
    }

    const char *pass_str = "Pass (undetected)";
    const char *ng_str = "Fault (detected)";

    if (bSuccess) {
        if (free_run_c == 0) {
            uint8_t los_c = (los >> in_sel_pllc) & 0x1;
            uint8_t oof_c = (oof >> in_sel_pllc) & 0x1;
            uint8_t lol_c = (lol >> 0x2) & 0x1;
            if (los_c != 0 || oof_c != 0 || lol_c != 0) {
                bSuccess = FALSE;
            }
            printf("CLK_from_SI5397A_p[0] (from IN%d):\r\n", in_sel_pllc);
            printf("\tInput (IN%d) Loss of Signal Fault Detection : %s\r\n", in_sel_pllc, los_c? ng_str: pass_str);
            printf("\tInput (IN%d) Out of Frequency Fault Detection: %s\r\n", in_sel_pllc, oof_c? ng_str: pass_str);
            printf("\tDSPLL (DSPLLC) Loss of Lock Fault Monitoring: %s\r\n", lol_c? ng_str: pass_str);
        }
        if (free_run_d == 0) {
            uint8_t los_d = (los >> in_sel_plld) & 0x1;
            uint8_t oof_d = (oof >> in_sel_plld) & 0x1;
            uint8_t lol_d = (lol >> 0x3) & 0x1;
            if (los_d != 0 || oof_d != 0 || lol_d != 0) {
                bSuccess = FALSE;
            }
            printf("CLK_from_SI5397A_p[1] (from IN%d):\r\n", in_sel_plld);
            printf("\tInput (IN%d) Loss of Signal Fault Detection : %s\r\n", in_sel_plld, los_d? ng_str: pass_str);
            printf("\tInput (IN%d) Out of Frequency Fault Detection: %s\r\n", in_sel_plld, oof_d? ng_str: pass_str);
            printf("\tDSPLL (DSPLLD) Loss of Lock Fault Monitoring: %s\r\n", lol_d? ng_str: pass_str);
        }
    }

    return bSuccess;
}

uint8_t last_page = 0;
bool SI5397A_w_reg(uint32_t i2c_base, uint8_t reg_index, uint8_t data8)
{

    bool bSuccess = TRUE;
    uint8_t dataR;
    if (reg_index == REGA_ADDR_PAGE) {
        last_page = data8;
    }
    const uint16_t w_only_reg[] = {
        0x001c, // Soft reset
        0x0230, // Px_UPDATE
        0x023f, // MXAXB_UPDATE
        0x030c, // N0_UPDATE
        0x0317, // N1_UPDATE
        0x0322, // N2_UPDATE
        0x032d, // N3_UPDATE
        0x0338, // N_UPDATE
        0x0420, // M_UPDATE_PLLA
        0x0520, // M_UPDATE_PLLB
        0x0614, // BW_UPDATE_PLLC
        0x0620, // M_UPDATE_PLLC
        0x0715, // BW_UPDATE_PLLD
        0x0721, // M_UPDATE_PLLD
    };
    const size_t w_only_reg_len = sizeof(w_only_reg) / sizeof(w_only_reg[0]);
    if (bSuccess) {
        bSuccess = SI5397A_w_reg_only(i2c_base, reg_index, data8);
    }
    if (bSuccess) {
        bSuccess = OC_I2C_Read(i2c_base, SI5397A_DeviceAddr, reg_index, &dataR, sizeof(dataR));
        //printf("[SI5397] read reg[0x%02x] = 0x%02x\r\n", reg_index, dataR );
    }

    if (!bSuccess) {
        printf("SI5397: failed to read page register\r\n");
    } else {
        if (dataR != data8) {
            uint16_t page_reg = (last_page << 8) | reg_index;
            bool skip = FALSE;
            for (int i = 0; i < w_only_reg_len; i++) {
                if (page_reg == w_only_reg[i]) {
                    skip = TRUE;
                    break;
                }
            }
            if (skip == FALSE) {
                bSuccess = FALSE;
                DEBUG(("[SI5397] read reg[0x%04x] = 0x%02x (expected:%02xh)\r\n", page_reg, dataR, data8));
            }
        }
    }

    return bSuccess;

}

bool SI5397A_w_reg_only(uint32_t i2c_base, uint8_t reg_index, uint8_t data8)
{

    bool bSuccess;

    bSuccess = OC_I2C_Write(i2c_base, SI5397A_DeviceAddr, reg_index, &data8, sizeof(data8));

    return bSuccess;

}

bool SI5397A_r_reg(uint32_t i2c_base, uint8_t reg_index, uint8_t *data8)
{

    bool bSuccess = TRUE;
    uint8_t dataR;
    uint16_t page_reg = (last_page << 8) | reg_index;
    if (bSuccess) {
        bSuccess = OC_I2C_Read(i2c_base, SI5397A_DeviceAddr, reg_index, &dataR, sizeof(dataR));
        DEBUG(("[SI5397] read reg[0x%04x] = 0x%02x\r\n", page_reg, dataR));
    }

    *data8 = dataR;

    return bSuccess;

}

